#ifndef MAC_PHY_TEST_H
#define MAC_PHY_TEST_H

#include <xemac.h>

//Ethernet device ID
#define DEVICE_ID       XPAR_EMAC_DEVICE_ID
//Maximum Ethernet frame size in word length
#define XEM_MAX_FRAME_SIZE_IN_WORDS ((XEM_MAX_FRAME_SIZE /sizeof(Xuint32)) + 1)

/******************* Gobal Variable Definitions *****************************/
static Xboolean FullDuplex = XTRUE;
static Xboolean FastEthernet = XTRUE; //100BaseT Mode

static Xuint8 LocalAddress[XEM_MAC_ADDR_SIZE] = {
    0x00, 0x11, 0x22, 0x33, 0x44, 0x55 };

/******************* Function Definitions **********************************/
int  emac_mfg_test(void);
int  emac_init(XEmac *InstancePtr, Xuint16 DeviceId);
int  emac_setMACOptions(XEmac *InstancePtr, Xuint32 Options);
int  emac_selfTest(XEmac *InstancePtr);

int  emac_loopBackFrame(XEmac *InstancePtr, Xuint32 PayloadSize);
int  emac_sendFrame(XEmac *InstancePtr, Xuint32 PayloadSize, Xuint8 *DestAddress);
int  emac_receiveFrame(XEmac *InstancePtr, Xuint32 PayloadSize, Xboolean Verify);

int  emac_phyTest(XEmac *InstancePtr, Xuint8 PhyAddress);
int  emac_phyLoopBackTest(XEmac *InstancePtr);
int  emac_setPHYOptions(XEmac *InstancePtr, Xboolean loopBack);
#endif
