/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */



/******************************************************************************



FILE



  $Id: peripheral.c,v 1.1 2005/02/17 20:26:46 crh Exp $



AUTHOR



  Welson Sun (welson@et.byu.edu)



DESCRIPTION

  

  This is the peripheral interfaces(LED,DIP,Pushbotton) API header for the XUP board.



NOTES

  

  None



******************************************************************************/



#include "peripheral.h"







/*****************************************************************************

 *

 * Init the peripheral

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/

void periphInit(Xuint32 baseAddr) {

	

	SWITCH_BASEADDR = baseAddr;

}



/*****************************************************************************

 *

 * Init the GPIO

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/

void init_gpio() {



    // DIP Switches

    // 3210       : XUP board naming convention

    // 0123       : GPIO bus naming convention

    XGpio_mSetDataDirection(SWITCH_BASEADDR,2, 0xf);

}



/*****************************************************************************

 *

 * Turn the specified LED on or off

 *

 * @param

 *   int ledNumber: Which LED using the board convention

 *   int on       : 1 is on, 0 is off

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/

void turnLED(int ledNumber, int on)

{

  //Nothing here for now

}





/*****************************************************************************

 *

 * Get the DIP switch status

 *

 * @param

 *   int dipNumber: Which DIP switch according to the board convention

 *

 * @return

 *   Xuint8       : 1 is HIGH,UP,CLOSED, 0 is LOW,DOWN,OPEN

 *

 * @note

 *   None

 *

 ******************************************************************************/

Xuint8 getDIP(int dipNumber)

{

    Xuint32 data;

    data = XGpio_mGetDataReg(SWITCH_BASEADDR, 2);

    data = (data>>(3-dipNumber)) & 0x1;

    return (Xuint8)(1-data);

}

