/******************************************************************************



FILE



  switches_buttons_IO.c ver 1.0 02/02/2005 



AUTHOR



  Mark Paluszkiewicz



DESCRIPTION

  

  This is the manufacturing test functions to test the following:
  expansion_hw_bist Enables the user mode walking ones test on the expasion ports
  contest1 Expansion ports no test board check fo rpin ti pin shorts
  contest2 Expansion ports check via test board for opens by reading bak the shift value
  userdip1 Test the user dip swites are all set to zero / up 
  userdip2 Test the user dip swites are all set to ones / down
  kbdps2
  mouseps2   



NOTES

  

  None



******************************************************************************/





#include "switches_buttons_IO.h"

/*****************************************************************************

 *

 * print_serial_num

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
void print_serial_num(void)
{
  volatile unsigned int sn_data_hi;
  int *psn_data_hi;
  volatile unsigned int sn_data_lo;
  int *psn_data_lo;
 psn_data_lo = (int *) SN_DATA_LO_ADDR;
 psn_data_hi = (int *) SN_DATA_HI_ADDR;
 sn_data_lo = *(psn_data_lo);
 sn_data_hi = *(psn_data_hi);
 
 if(sn_data_hi == 0 && sn_data_lo == 0) // test for any serial number
 {
 print("o.fail\n");  // serial number is still the reset value  -- fail
 }
 print("o.pass.");
 xil_printf("%04x",sn_data_hi);
 //putnum(sn_data_hi);
 putnum(sn_data_lo);
 print("\n");
 return ;
}

/*****************************************************************************

 *

 * expansion_hw_bist

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
void expansion_hw_bist(void)
{
 unsigned char  s;
 s= 0;
  clearScreen();
  print("Expansion Connector Walking Ones Test.\r\n");
  print("------------------------------------------");
  print("\n\rWARNING: Make sure no expansion boards are connected to the expansion connectors.!!!\r\n\r\n");
  print("Type y to continue, n to cancel.\r\n"); 
   s = uartRead();
   if(s == 'y'){
     print("\n\rWalking ONEs test running on expansion connectors !\n\r");
     XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x011); // turn on ouput enables for hardware walking ones test
     getQuitInput();
	 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x001);  // turn off walking ones test
     return;
	 }
    if(s == 'n'){ 
	  return ;
	  }
} 

/*****************************************************************************

 *

 * conntest1

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
void conntest1(void)
{
 int i,j;
 int failed = 0; 
 volatile unsigned int port_data_hi;
 volatile unsigned int port_data_lo;
 int *pport_data_hi;
 int *pport_data_lo;
 pport_data_lo = (int *) XPAR_GPIO_PORT_DATA_BASEADDR;
 pport_data_hi = (int *) XPAR_GPIO_PORT_DATA_BASEADDR + 2; 
 // read before first shift
 port_data_lo = *(pport_data_lo);
 port_data_hi = *(pport_data_hi);

 if(port_data_hi != 0 || port_data_lo != 0)
 	{
 	print("j.error.short_to_1.\n");  // fail if a one is read, due to short to vcc
 	failed = 1;
 	}
 clock_in_first_bit(); // clock and shift in one data bit

 for( i= 0 ; i< 54; i++)
 {
 //xil_printf("shift positon %d input =", i);
 port_data_lo = *(pport_data_lo);  //read port after a one is written to a pair
 port_data_hi = *(pport_data_hi);

  	if(port_data_hi != 0 || port_data_lo != 0)  // nonzero means a short on pcb
 		{
 		xil_printf("j.error.shorted_pair#%d\n",i);
    	failed = 1;  // set failed flag to continue shifting to clear shift register
 		}

 toggle_software_shift_clock();
 }// end of for loop
 if( failed)
 	{
	 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1); 
	print("j.fail\n");
	return; // if failed leave quitely
	}
 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1); 
 print("j.pass\n"); // print passed with no failures detected

}// end of contest1

/*****************************************************************************

 *

 * conntest2

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
void conntest2(void)
{
 int i,j, wait;
 int failed = 0; 
 volatile unsigned int port_data_hi;
 volatile unsigned int port_data_lo;
 volatile int *pport_data_lo;
 volatile int *pport_data_hi;
 unsigned int comp_data_lo = 1;                     // star with first bit set in compare dword
 unsigned int comp_data_hi = 0;
 pport_data_lo = (int *) XPAR_GPIO_PORT_DATA_BASEADDR;
 pport_data_hi = (int *) XPAR_GPIO_PORT_DATA_BASEADDR + 2;
 // read before first shift
 port_data_lo = *(pport_data_lo);
 port_data_hi = *(pport_data_hi);

 if(port_data_hi != 0 || port_data_lo != 0)        // check for a high without any oututs on
 	{
 	print("r.error.short2vcc.\n");                  // fail if a one is read, due to short to vcc
	failed = 1; 
 	}
 clock_in_first_bit();                              // clock and shift in one data bit

 for( i= 0 ; i< 54; i++)
 {
 port_data_lo = *(pport_data_lo);                   //read port after a one is written to a pair
 port_data_hi = *(pport_data_hi);
	if( i == 32)
		{
		comp_data_lo = 0;
		comp_data_hi = 1;                          // set first bit in upper dword
		}
	if( i == 53)
		{
		comp_data_lo = 0;
		comp_data_hi = 0;
		}
  	if(i < 32 && port_data_lo !=  comp_data_lo)  //mismatach
 		{
 		xil_printf("r.error.at_pair#%d\n",i);
    	failed = 1;                             // set failed flag to continue shifting to clear shift register
 		}
	if(i > 31 && port_data_hi !=  comp_data_hi) //mismatach
 		{
 		xil_printf("r.error.at_pair#%d\n",i);
    	failed = 1;                             // set failed flag to continue shifting to clear shift register
 		}
 toggle_software_shift_clock();
 wait = 1000;
 while(wait)                                    // delay read of next input to let weak pull downs zero last pin
 	{
 	wait--;
	}  
 comp_data_lo = comp_data_lo << 1;
 comp_data_hi = comp_data_hi << 1;

 }// end of for loop
 if( failed)
 	{
	XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1); 
	print("r.fail\n");
	return;                                     // if failed 
	}
 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1); 
 print("r.pass\n");                             // print passed
}// end of contest2 

/*****************************************************************************

 *

 * userdip1

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/

void userdip1(void)
{
 volatile int *psw_data;
 volatile unsigned int switches;
 psw_data = (int *) XPAR_GPIO_BASEADDR + 2;

   switches = *(psw_data);              // read the gpio port 
  if( !(DIPSW_AND_MASK  & switches))    // mask the dip switches only test for all low
     { 
     print("d.pass\n");
	 return;
	 }
	 else
	 {
      print("d.fail\n");
	  return;
	 }
}// end of userdip1

/*****************************************************************************

 *

 * userdip2

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/

void userdip2(void)
{
 volatile int *psw_data;
 volatile unsigned int switches;
 psw_data = (int *) XPAR_GPIO_BASEADDR + 2;

  switches = *(psw_data);                 // read the gpio port 
  switches = DIPSW_AND_MASK  & switches;  // mask the dip switches only
  if(DIPSW_AND_MASK  ==  switches)        // verify they are all ones
     { 
     print("e.pass\n");
	 return;
	 }
	 else
	 {
      print("e.fail\n");
	  return;
	 }
}// end of userdip2

/*****************************************************************************

 *

 * kbdps2

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
/*
     3           4       |   5          6          7       8 | 9  10  11  12
  test enable  mouse clk | key clk  mouse data  key data   0 | 0   0   0   0


  test key data   = 0x000003D0 LO 
  test key clk    = 0x00000360 LO 
  test mouse data = 0x000003A0 LO 
  test mouse clk  = 0x000002E0 LO

  MOUSE_CLK_AND_MASK  0x00001000
  MOUSE_D_AND_MASK    0x00000400
  KEYBD_CLk_AND_MASK  0x00000800
  KEYBD_D_AND_MASK    0x00000200

*/
void kbdps2(void)
{
  volatile int *psw_data;
  volatile unsigned int switches;
  psw_data = (int *) XPAR_GPIO_BASEADDR + 2;

                  
  XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,0x00000361);  // set keyboard clock lo
  switches = *(psw_data);                               // read the gpio port
                              
  if(KEYBD_D_AND_MASK & switches)
    {
	XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1);         // cleanhouse leave GPIO = 0
    print("l.fail\n");
    return;
    }
  XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,0x000003D1);  // set keyboard data lo
  switches = *(psw_data);                               // read the gpio port 
  if(KEYBD_CLk_AND_MASK & switches)
    {
	XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1);        // cleanhouse leave GPIO = 0
    print("l.fail\n");
    return;
    }
  XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1);          // cleanhouse leave GPIO = 0
  print("l.pass\n");
  return;

}// end of  kbdps2

/*****************************************************************************

 *

 * mouseps2

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
void mouseps2(void)
{
 volatile int *psw_data;
 volatile unsigned int switches;
 psw_data = (int *) XPAR_GPIO_BASEADDR + 2;
                 
  XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,0x000002E1);  // set mouse clock lo
  switches = *(psw_data);                               // read the gpio port
  if( MOUSE_D_AND_MASK & switches)
    {
	XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1);         // cleanhouse leave GPIO = 0
    print("m.fail\n");
    return;
    }
  XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,0x000003A1);  // set mouse data lo
  switches = *(psw_data);                               // read the gpio port 
  if(MOUSE_CLK_AND_MASK & switches)
    {
	XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1);         // cleanhouse leave GPIO = 0
    print("m.fail\n");
    return;
    }
  XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1,1);          // cleanhouse leave GPIO = 0
  print("m.pass\n"); 
  return;

}// end of mouseps2 





/*****************************************************************************

 *

 * toggle_software_shift_clock

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
void toggle_software_shift_clock(void)
{

 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x001);
 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x003);
 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x001);
 return;

}

/*****************************************************************************

 *

 * clock in first bit 

 *

 * @param

 *   None

 *

 * @return

 *   None

 *

 * @note

 *   None

 *

 ******************************************************************************/
void clock_in_first_bit(void)
{

 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x005);
 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x007);
 XGpio_mSetDataReg(XPAR_GPIO_BASEADDR, 1, 0x001);
 return;

}

