/******************************************************************************



FILE



  switches_buttons_IO.h ver 1.0 02/02/2005 



AUTHOR



  Mark Paluszkiewicz



DESCRIPTION

  

  This is the manufacturing test functions to test the following:
  expansion_hw_bist Enables the user mode walking ones test on the expasion ports
  contest1 Expansion ports no test board check fo rpin ti pin shorts
  contest2 Expansion ports no test board check fo rpin ti pin shorts
  userdip1
  userdip2
  kbdps2
  mouseps2   



NOTES

  

  None



******************************************************************************/



#ifndef SWITCHES_BUTTONS_IO_H

#define SWITCHES_BUTTONS_IO_H



/*****************************************************************************

Including files

*****************************************************************************/

#include <xgpio_l.h>

#include <xparameters.h>




#define SN_DATA_LO_ADDR  XPAR_GPIO_SN_DATA_BASEADDR
#define SN_DATA_HI_ADDR  XPAR_GPIO_SN_DATA_BASEADDR + 8
#define DIPSW_AND_MASK      0x0000000F
#define MOUSE_CLK_AND_MASK  0x00001000
#define MOUSE_D_AND_MASK    0x00000400
#define KEYBD_CLk_AND_MASK  0x00000800
#define KEYBD_D_AND_MASK    0x00000200

/*****************************************************************************

Function prototypes

*****************************************************************************/

void print_serial_num(void);
void expansion_hw_bist(void);
void conntest1(void);
void conntest2(void);
void userdip1(void);
void userdip2(void);
void kbdps2(void);
void mouseps2(void);  
void toggle_software_shift_clock(void);
void clock_in_first_bit(void);






#endif
