#include <xsysace.h>
#include "uart.h"
#include "sysace.h"


static Xuint32 SYSACE_BaseAddress;

void sysaceInit(Xuint32 base_address) {
  SYSACE_BaseAddress = base_address;
}

int sysaceTest(print_on) {
  Xuint32 sysace_status;
  XSysAce sSysAceStruct;
  XSysAce *SysAcePtr;
  int SysaceVerNo = 0 ;

  SysAcePtr = &sSysAceStruct;
  sSysAceStruct.BaseAddress = SYSACE_BaseAddress;
 if(print_on){
  clearScreen();
  print("\r\nSYSACE Self Test");
  print("\r\n----------------\r\n");

  print("Initalizing sysace...\t\t");
  }
  XSysAce_Initialize(SysAcePtr,0);
  if(print_on){
  print("done!\r\n");

  print("Querying device version...\t");
  }
  SysaceVerNo = XSysAce_GetVersion(SysAcePtr);
  if( SysaceVerNo == 0){
    if(print_on){    
      print(" error accessing SYSACE!\r\n");
	  }
	  else
	  {
	  print("k.fail\n");
	  }
    return 0;
  }
    if(print_on){ 
  	  print("done!\r\n");

  	  xil_printf("  Identified SYSACE version #%d\r\n", SysaceVerNo);
 
  	  print("Querying formatted memory device...\t");
      }
  sysace_status = XSysAce_mGetStatusReg(SYSACE_BaseAddress);
  if( sysace_status & XSA_SR_CFDETECT_MASK ) { 
    if(print_on){ 
	    print("SUCCESS!\r\n");
	    }
    XSysAce_Lock(SysAcePtr, XTRUE);
    XSysAce_ResetCfg(SysAcePtr);
  }
  else
   if(print_on){ 
      print("FAILED - No memory device found.\r\n");
      }
	else
      {
	  print("k.fail\n");
	  return 0;
	  }
	if(print_on){
      getQuitInput();
	  }
	  else
      print("k.pass\n");
  return 0;

}

