/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */

/******************************************************************************

FILE

  $Id: web.c,v 1.1 2005/02/17 20:26:46 crh Exp $

AUTHOR

  Welson Sun (welson@et.byu.edu)

DESCRIPTION
  
  This is source file for WEB server

NOTES

  None

******************************************************************************/

#include "web.h"

/*****************************************************************************
Global variables
*****************************************************************************/

int count = 0;

int stop_webserver=0;

int iswebinit = 0;

Xuint8 ip[16]="192.168.0.3";

unsigned char dip[7];

static Xuint32 WEB_BaseAddress;

struct web_conn_ent web_conns[MAX_WEB_CONNS];

unsigned char file_not_found[] = "HTTP/1.1 404 Not Found\r\nContent-type: text/html\n\rConnection: close\r\n\r\nFile Not Found!";

unsigned char http_hdr[] = "HTTP/1.1 200 OK\n\rContent-type: text/html\n\rConnection: close\n\r\r\n";

unsigned char *bg_tab[] = {
    "#63B1B1","#FFFFCC","#808040","#FFCC99","#CC6600", "#99FF99"};
unsigned char *index1 = "<html><head></head><body bgcolor=\"";

unsigned char *index_html = "\"><center><b><font size=+3>PowerPC Web Server on Xilinx XUP Board</font></b></center><br><font face=\"Garamond\">A Simple Web Server running on PowerPC, check out the following demos.</font><p><b><font face=\"Garamond\">Simple Parsing:</font></b><p><font face=\"Garamond\">Input \"x\" or \"X\" to stop the webserver, other values or blank to reload the page.</font><br><form action=\"pl\" method=\"get\"><input type=\"text\" size=\"1\" name=\"textbox\"><input type=\"submit\" value=\"Submit\"><br></form><font face=\"Garamond\"></font><p><b><font face=\"Garamond\">Changing Colors :</font></b><p><font face=\"Garamond\">See the background color of the page change everytime when reloaded.<p><a href=\"index2.html\">Yet Another File on PowerPC</a></font><p><b><font face=\"Garamond\">DIP Switches:</font></b><font face=\"Garamond\"></font><p><font face=\"Garamond\">Set Dip Switches 3 2 1 0 and see it displayed as binary on reload</font><b><font face=\"Garamond\"></font></b><p><b><font face=\"Garamond\">DIP Value: ";

// Character string for the index2.html file.
unsigned char *index2_html ="\"><center><b><font size=+3>PowerPC Web Server on Xilinx XUP Board</font></b></center><br><font face=\"Garamond\">index2.html on <b>PowerPC</b>.<p><a href=\"index.html\">Back</a></font></body></html>";

unsigned char *stop_html = "\"><center><b><font size=+3>Web Server Stopped!</font></b></center></body></html>";


/*****************************************************************************/
/*
 * This function inits the EMAC controller base address
 *
 * @param
 *   Xuint32 baseAddr: EMAC controller base address
 *
 * @return
 *   None
 *
 * @note
 *   None
 *
 ******************************************************************************/
void webInit(Xuint32 baseAddr)
{
	WEB_BaseAddress = baseAddr;
}


/*****************************************************************************/
/*
 * The main loop of the WEB server
 *
 * @param
 *   None
 *
 * @return
 *   None
 *
 * @note
 *   None
 *
 ******************************************************************************/
void web()
{   
	int i;
    int n = 0;
    int s;
    int err;
    struct sockaddr_in addr;
    
    // Initialize general purpose I/O
    init_gpio();

    // Initialize network device
    init_net();

	// Create the socket
    s = init_socket(&addr);
    if (s == -1) {
        xil_printf("socket() error \n\r");
        exit(1);
    }

    stop_webserver = 0;
    
	for (;;) {

        int alen = 0; 
        
        count = count % 6;        
        
        /* Accept new connections */
        alen = sizeof(struct sockaddr);

        // Accept a new connection. Sets the global xilsock_status_flag.
        err = xilsock_accept(s, (struct sockaddr *)&addr, &alen);
        if (xilsock_status_flag & XILSOCK_NEW_CONN) {
            /* A new connection was found. Add a web connection. */
            add_web_conn(err);
        } 
        /* Process all existing connections */
        if (do_proc_conns()==-1){
            print("WEB server stoped\r\n");
            return;
        }
    }

    return;
}


/*****************************************************************************/
/*
 * Init the Ethernet interface
 *
 * @param
 *   None
 *
 * @return
 *   None
 *
 * @note
 *   None
 *
 ******************************************************************************/
void init_net() {

    unsigned char hw_addr[]="00:11:22:33:44:55";
       
	xil_printf("\r\n\r\nXUP MAC Address: %s, make sure it is allowed in your network.\r\n", hw_addr);

    // Set MAC address (eth.c) of hardware in the TCP/IP stack
    xilnet_eth_init_hw_addr(hw_addr);
    
    // Initialize Ethernet hardware table (eth.c)
    xilnet_eth_init_hw_addr_tbl();
    
    // Set the IP address  (ip.c)
    getIP(ip);
    xilnet_ip_init(ip);

    // Initialize the MAC OPB base address (MAC driver in net/mac.c)
    xilnet_mac_init(WEB_BaseAddress);
    
    // xemac_l.h
    //xil_printf("\r\nReseting PHY\n\r");
    XEmac_mPhyReset(WEB_BaseAddress);
    
    // Set the MAC physical Ethernet address in the MAC driver (xemac_l.h)
    XEmac_mSetMacAddress(WEB_BaseAddress, mb_hw_addr);
    
    // Enable MAC (xemac_l.h)
    XEmac_mEnable(WEB_BaseAddress);
    
    // Print IP address
    xil_printf("\r\nWEB server IP: %d.%d.%d.%d \n\r",
               mb_ip_addr[0], mb_ip_addr[1],mb_ip_addr[2],mb_ip_addr[3]);
    
}


/*****************************************************************************/
/*
 * Init the socket interface
 *
 * @param
 *   struct sockaddr_in *addr: Socket address
 *
 * @return
 *   int: status
 *
 * @note
 *   None
 *
 ******************************************************************************/
int init_socket(struct sockaddr_in *addr) {
    //struct sockaddr_in addr; // defined in net/in.h
    int s;
    int err;
    
    // Allocate a new socket (xilsock.c)
    s = xilsock_socket(AF_INET, SOCK_STREAM, 0);
    if (s == -1) {
        return -1;
    }
    
    // Define the address for the socket
    addr->sin_family = AF_INET;          //socket.h (IP)
    addr->sin_addr.s_addr = INADDR_ANY;  //net/in.h
    addr->sin_port = SERVER_PORT;        //defined in web.h (web server at 8080)
    
    //Bind the allocated socket to a specific address
    err = xilsock_bind(s, (struct sockaddr *)addr, sizeof(struct sockaddr));
    if (err == -1) {
        xil_printf("bind() error \n\r");
        return(-1);
    }
    
    
    // Enable listening on the socket
    err = xilsock_listen(s, 4);
    if (err == -1) {
        xil_printf("listen() error \n\r");
        return -1;
    }
    
    print("\r\nWEB server started.\r\n");
    xil_printf("Type http://%s:8080 in your browser to test the WEB server.\r\n",ip);
    print("Follow the instruction on the WEB page to stop the WEB server\r\n");
    
    return s;
    
}

/*****************************************************************************/
/*
 * Get the IP address
 *
 * @param
 *   unsigned char* ipAddr: The IP address to put
 *
 * @return
 *   None
 *
 * @note
 *   None
 *
 ******************************************************************************/
void getIP(unsigned char* ipAddr)
{
  int i;
  Xuint8 correct = 'n';
  Xuint8 tempIP[16];
  
  while(correct != 'y'){
    
    xil_printf("\r\nInput your IP address, hit ENTER directly for default/previous address\r\n(%s):", ip);
    for(i=0;i<16;i++){
      //ipAddr[i] = uartRead();
      tempIP[i] = uartReadEcho();
      if(tempIP[i]=='\r')
        break;
    }
    xil_printf("\n");

    if(i==0){
      strcpy(tempIP,ip);
      i=strlen(ip);
    }
    
    xil_printf("Are you sure this IP address is correct?(y/n)");
    correct = uartRead();
  }

  tempIP[i]='\0';

  strcpy(ipAddr,tempIP);

}


/*****************************************************************************/
/*
 * Process specified connection
 *
 * @param
 *   int n: Connection number
 *
 * @return
 *   int : Status
 *         -1 : Terminate WEB server
 *         0  : Normal
 *
 * @note
 *   None
 *
 ******************************************************************************/
int do_proc_req(int n) {

    char fname[15] = {0};
    int  num;
    char *tok;
    char d2;

    // Obtain a pointer to the location in the "send frame" where the
    // data is supposed to start. The pointer needs to
    // skip over all of the header information.
    unsigned char *sndptr = (unsigned char*)(sendbuf +
                                             LINK_HDR_LEN +
                                             IP_HDR_LEN*4 +
                                             (TCP_HDR_LEN*4));
    int i1len, bglen;

    unsigned int http_hdr_len = strlen(http_hdr);
    
    // Obtain a pointer to the receive buffer.
    // Global array of sockets (xilsock.h)
    unsigned char *receive_buffer = xilsock_sockets[web_conns[n].s].recvbuf.buf;
    
    if (!receive_buffer)
        return 0; 
    
    /*
     * Ack for Data Sent
     */
    if (xilsock_status_flag & XILSOCK_TCP_ACK) {
        xil_printf("XILSOCK_TCP_ACK\r\n");
        xilsock_close(web_conns[n].s);
        free_web_conn(n);
        if(stop_webserver)
            return -1;
        else
            return 0;
    }
    /*
     * GET Request
     */
    else if (xilsock_status_flag & XILSOCK_TCP_DATA) {
        int i;
        
        xil_printf("XILSOCK_TCP_DATA\r\n");
        /*
         * Read DIP switches
         */
        dip[0] = getDIP(3) + 48;
        dip[1] = getDIP(2) + 48;
        dip[2] = getDIP(1) + 48;
        dip[3] = getDIP(0) + 48;
        dip[4] = ' '; //getDIP(4) + 48;
        dip[5] = ' '; //getDIP(5) + 48;
        dip[6] = ' '; //getDIP(6) + 48;
        
        i1len = strlen(index1);
        bglen = strlen(bg_tab[count]);
        
        // Find the first space in the receive buffer
        tok = strtok(receive_buffer, " ");
        // Find the scond space in the receive buffer
        tok = strtok('\0', " ");
        // Increment the pointer.
        tok ++;
        
        xil_printf("Processing Request...\n\r");

        // See if "pl" action method is requested.
        if (tok[0] == 'p' && tok[1] == 'l') {

            xil_printf("pl action method\r\n");
			d2 = tok[11];

            if (d2 >= '0' && d2 <= '7' )
	            d2 = tok[11] - 48 ;
            else if ( d2 == 'x' || d2 == 'X' ){
                stop_webserver = 1;
                strcpy(fname,"stop.html");
            }
			turnLED(-1, 0);
            turnLED(d2, 1);
        }
        else {
            int i;
			xil_printf("File name given\r\n");
            // Instead, a filename is given as a parameter
            strcpy(fname,tok);
			for(i=0; i<15; i++)
				xil_printf("%c",fname[i]);
			xil_printf("\r\n");
        }
        
        // part of stdlib. Fills the 'sendbuf' buffer with all zeros
        memset(sendbuf, 0, LINK_FRAME_LEN);
        
        /**
         * Fill HTTP header and send requested file
         */
        // Set the HTTP 1.1 header
        memcpy(sndptr, http_hdr, http_hdr_len);
        if (!(*fname))
            // if no filename is specified, use "index.html"
            strcpy(fname, "index.html");

        xil_printf("Send on socket: %d\r\n", web_conns[n].s);
        
        // Open the file that was sent
        if ( !strcmp(fname,"index.html")) {
            int diplen = 7;
            memcpy((sndptr+http_hdr_len+i1len+bglen),index_html,strlen(index_html));
            strcat((sndptr+http_hdr_len+i1len+bglen), dip);
            
            memcpy((sndptr+http_hdr_len+i1len), bg_tab[count], bglen);
            memcpy((sndptr+http_hdr_len), index1, i1len);
            num = xilsock_send(web_conns[n].s, sendbuf, strlen(index_html)+http_hdr_len+i1len+bglen+diplen);
            memset(sendbuf, 0, 1514);
            xil_printf("done..\n\r");
        }else if( !strcmp(fname, "index2.html") ){
            memcpy((sndptr+http_hdr_len+i1len+bglen),index2_html,strlen(index2_html));
            memcpy((sndptr+http_hdr_len+i1len), bg_tab[count], bglen);
            memcpy((sndptr+http_hdr_len), index1, i1len);
            num = xilsock_send(web_conns[n].s, sendbuf, strlen(index2_html)+http_hdr_len+i1len+bglen);
            memset(sendbuf, 0, 1514);
            xil_printf("done..\n\r");
        }else if( !strcmp(fname, "stop.html") ){
            memcpy((sndptr+http_hdr_len+i1len+bglen),stop_html,strlen(stop_html));
            memcpy((sndptr+http_hdr_len+i1len), bg_tab[count], bglen);
            memcpy((sndptr+http_hdr_len), index1, i1len);
            num = xilsock_send(web_conns[n].s, sendbuf, strlen(stop_html)+http_hdr_len+i1len+bglen);
            memset(sendbuf, 0, 1514);
            xil_printf("done..\n\r");
        }
        else {
            xil_printf("file not found \n\r");       
            // send http file not found message
            memcpy(sndptr, file_not_found, 24);
            memcpy(&sndptr[24], "File Not Found", strlen("File Not Found"));
            // send file not found message to socket
            n = xilsock_send(web_conns[n].s, sendbuf, strlen(sndptr));
        }
        count++;

        return 0;
    }
    
}

/*****************************************************************************/
/*
 * Initialise all web connections
 *
 * @param
 *   None
 *
 * @return
 *   None
 *
 * @note
 *   None
 *
 ******************************************************************************/
void init_web_conns() {
    int i;

    for (i = 0; i < MAX_WEB_CONNS; i++) {
        web_conns[i].s =-1;
        web_conns[i].file_name = NULL;
        web_conns[i].bytes_rem = 0;
        web_conns[i].state = WEB_CONN_FREE;
    }
    iswebinit = 1;
}

/*****************************************************************************/
/*
 * Add a web connection
 *
 * @param
 *   int s:  Socket number
 *
 * @return
 *   int : Status
 *         -1 : Error
 *         other: connection number
 *
 * @note
 *   None
 *
 ******************************************************************************/
int add_web_conn(int s) {

    int i;
    
    
    //If WEB is not initialized, init it
    if (!iswebinit)
        init_web_conns();
    
    //Looking for a free WEB connection
    for ( i = 0; i < MAX_WEB_CONNS; i++) {
        if (web_conns[i].state == WEB_CONN_FREE)
            break;
    }
    
    if ( i < MAX_WEB_CONNS) {
        //If there is one free
        web_conns[i].s = s;
        web_conns[i].state = WEB_GET;

        xil_printf("Add Web Conn, socket: %d\n\r", web_conns[i].s);

        return i;
    }else{
        xil_printf("no free conns \n\r");
        return -1;
    }
}

/*****************************************************************************/
/*
 * Free a web connection
 *
 * @param
 *   int s:  Connection number
 *
 * @return
 *   int : Status
 *         -1 : Error
 *         other: connection number
 *
 * @note
 *   None
 *
 ******************************************************************************/
void free_web_conn(int s) {
    web_conns[s].s = -1;
    web_conns[s].state = WEB_CONN_FREE;
}

/*****************************************************************************/
/*
 * Process all web connections
 *
 * @param
 *   None
 *
 * @return
 *   int : Status
 *         -1 : Terminate WEB server
 *         other: Normal
 *
 * @note
 *   None
 *
 ******************************************************************************/
int do_proc_conns() {
   int i, result;
   
   for (i = 0; i < MAX_WEB_CONNS; i++){
       result = do_proc_req(i);
       // reset buf ptrs of sockets
       xilsock_sockets[web_conns[i].s].recvbuf.buf = NULL;
       xilsock_sockets[web_conns[i].s].recvbuf.size = 0;
   }
   return result;
}
