/* -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */

/******************************************************************************

FILE

  $Id: web.h,v 1.1 2005/02/17 20:26:46 crh Exp $

AUTHOR

  Welson Sun (welson@et.byu.edu)

DESCRIPTION
  
  This is the WEB server header file

NOTES
  
  None

******************************************************************************/

#ifndef WEB_H
#define WEB_H

/*****************************************************************************
Including files
*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <net/xilnet_config.h>
#include <net/xilsock.h>
#include <xgpio_l.h>
#include <xemac_l.h>
#include <xparameters.h>
#include "peripheral.h"

/*****************************************************************************
Definitions
*****************************************************************************/
#define SERVER_PORT 8080
#define MAX_WEB_CONNS 1

// Web Server States for connections
#define WEB_GET        1    // Got a Get request
#define WEB_GET_PROC   2    // processing a GET request
#define WEB_DONE       3    // done with a GET request processing
#define WEB_CONN_FREE  -1   // conn free to assign to client

struct web_conn_ent {
    int s;                  // socket descriptor
    int state  ;            // state of the connection
    char *file_name;        // name of file served
    int bytes_rem;          // no of bytes remaining to send 
};

/*****************************************************************************
Function prototypes
*****************************************************************************/
void webInit(Xuint32);
void web(void);
void init_net(void);
int init_socket(struct sockaddr_in *);
void getIP(unsigned char*);
int do_proc_req(int);
int add_web_conn(int);
void free_web_conn(int);
int do_proc_conns();

#endif
