//=============================================================================
//
//    File Name:  synth_defs.v      
//      Version:  2.2
//         Date:  05/12/2003
//      Company:  Xilinx, Inc.
//
//   Disclaimer:  XILINX IS PROVIDING THIS DESIGN, CODE, OR
//                INFORMATION "AS IS" SOLELY FOR USE IN DEVELOPING
//                PROGRAMS AND SOLUTIONS FOR XILINX DEVICES.  BY
//                PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
//                ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
//                APPLICATION OR STANDARD, XILINX IS MAKING NO
//                REPRESENTATION THAT THIS IMPLEMENTATION IS FREE
//                FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE
//                RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY
//                REQUIRE FOR YOUR IMPLEMENTATION.  XILINX
//                EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH
//                RESPECT TO THE ADEQUACY OF THE IMPLEMENTATION,
//                INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//                REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
//                FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES
//                OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//                PURPOSE.
//
//                (c) Copyright 2003 Xilinx, Inc.
//                All rights reserved.
//
//=============================================================================



//=============================================================================
// Define only one of following parameters at a time to configure the type
// MGT clock source
//=============================================================================
  `define USE_DIFF_CLK      // If this parameter is defined, XBERT will 
                            // use differential clock inputs to drive 
                            // RocketIO transceivers. 
//  `define NOT_USE_DIFF_CLK  // If this parameter is defined, XBERT will 
                            // use single clock input to drive RocketIO 
                            // transceivers. 

//=============================================================================
// Define one of the following parameter to attach ChipScope ILA on the pattern
// follower in one of the XBERTs. If none of the following parameter is
// defined, there will be no ChipScope ILA attached.
//=============================================================================
`define USE_ILA

//=============================================================================
// Define the following parameter to enable Echo Mode.  If not defined the 
// Aurora Tester will not be able to perform Echo. 
//=============================================================================
`define USE_ECHO

//=============================================================================
// Define the following parameter to enable random data and packet size 
// generation.  If not defined the Aurora Tester will not be able to send and
// receive random data or send random sized packets.
//=============================================================================
`define USE_RANDOM

//=============================================================================
// Define the following parameters at a time to configure the XBERT
// XBERT will load its parameter set defined in BERT_CONFIG.v for
// implementation  purpose.
// Note: Do not modify this parameter
//=============================================================================
 //`define AT_FOR_SIM_ONLY
`define AT_MGT_DEMO_BOARD

//=============================================================================
// USE_TOP_AURORA:
//     If defined, two Aurora cores are instantiated, else
//     only the bottom core for the device is instantiated. 
//=============================================================================

`define USE_TOP_AURORA
