//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
/*
-------------------------------------------------------------------------------
   Title      : HEX to ASCII conversion
   Project    : XUP Virtex-II Pro Demonstration System
-------------------------------------------------------------------------------
   File       : HEX_2_ASCII.v
   Company    : Xilinx, Inc.
   Created    : 2001/07/02
   Last Update: 2001/07/02
   Copyright  : (c) Xilinx Inc, 2001
-------------------------------------------------------------------------------
   Uses       : 
-------------------------------------------------------------------------------
   Used by    : 
-------------------------------------------------------------------------------
   Description: This module converts HEX digits into ASCII for display.
			This is used to display the MicroBlaze Demo Board
			MAC address.
-------------------------------------------------------------------------------
*/

module HEX_2_ASCII (
hex,
ascii
);
input [3:0] hex;
output [7:0] ascii;

reg [7:0] ascii;

always @ (hex) begin
case (hex[3:0])

4'b0000:begin
	ascii = 8'h30;
	end
4'b0001:begin
	ascii = 8'h31;
	end
4'b0010:begin
	ascii = 8'h32;
	end
4'b0011:begin
	ascii = 8'h33;
	end
4'b0100:begin
	ascii = 8'h34;
	end
4'b0101:begin
	ascii = 8'h35;
	end
4'b0110:begin
	ascii = 8'h36;
	end
4'b0111:begin
	ascii = 8'h37;
	end
4'b1000:begin
	ascii = 8'h38;
	end
4'b1001:begin
	ascii = 8'h39;
	end
4'b1010:begin
	ascii = 8'h41;
	end
4'b1011:begin
	ascii = 8'h42;
	end
4'b1100:begin
	ascii = 8'h43;
	end
4'b1101:begin
	ascii = 8'h44;
	end
4'b1110:begin
	ascii = 8'h45;
	end
4'b1111:begin
	ascii = 8'h46;
	end
endcase
end
endmodule  //HEX_2_ASCII

